/**
 * Application Migration Service API
 * API for the Application Migration service. Use this API to migrate applications from Oracle Cloud Infrastructure - Classic to Oracle Cloud Infrastructure.

 * OpenAPI spec version: 20191031
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Information required to migrate an application. Populated by the service as the source application is introspected
 *
 */
export interface ConfigurationField {
    /**
     * The name of the configuration field
     */
    "name"?: string;
    /**
     * The name of the group to which this field belongs, if any.
     */
    "group"?: string;
    /**
     * The configuration field type
     */
    "type"?: string;
    /**
     * The value of the field
     */
    "value"?: string;
    /**
     * Help text to guide the customer in setting the configuration value
     */
    "description"?: string;
    /**
     * Indicates whether or not the field is required (defaults to true)
     *
     */
    "isRequired"?: boolean;
    /**
     * Indicates whether or not the field may be modified (defaults to true)
     *
     */
    "isMutable"?: boolean;
}
export declare namespace ConfigurationField {
    function getJsonObj(obj: ConfigurationField): object;
}
