/**
 * Application Migration Service API
 * API for the Application Migration service. Use this API to migrate applications from Oracle Cloud Infrastructure - Classic to Oracle Cloud Infrastructure.

 * OpenAPI spec version: 20191031
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * An application being migrated from a source environment to OCI.
 *
 */
export interface Migration {
    /**
     * Unique identifier (OCID) for the application
     */
    "id"?: string;
    /**
     * Unique idenfifier (OCID) for the compartment where the Source is located.
     *
     */
    "compartmentId"?: string;
    /**
     * Human-readable name of the migration.
     */
    "displayName"?: string;
    /**
     * Description of the migration.
     */
    "description"?: string;
    /**
     * The date and time at which the migration was created.
     */
    "timeCreated"?: Date;
    /**
     * Unique identifier (OCID) of the application source.
     */
    "sourceId"?: string;
    /**
     * Name of the application being migrated from the source.
     */
    "applicationName"?: string;
    /**
     * The type of application being migrated.
     */
    "applicationType"?: model.MigrationTypes;
    /**
     * Configuration required to migrate the application. In addition to the key and value, additional fields are provided to describe type type and purpose of each field. Only the value for each key is required when passing configuration to the CreateMigration operation.
     *
     */
    "serviceConfig"?: {
        [key: string]: model.ConfigurationField;
    };
    /**
     * Configuration required to migrate the application. In addition to the key and value, additional fields are provided to describe type type and purpose of each field. Only the value for each key is required when passing configuration to the CreateMigration operation.
     *
     */
    "applicationConfig"?: {
        [key: string]: model.ConfigurationField;
    };
    /**
     * The current state of the Migration
     */
    "lifecycleState"?: string;
    /**
     * Details about the current lifecycle state
     */
    "lifecycleDetails"?: string;
    /**
     * The current state of the overall Migration process
     */
    "migrationState"?: string;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace Migration {
    function getJsonObj(obj: Migration): object;
}
