/**
 * Application Migration Service API
 * API for the Application Migration service. Use this API to migrate applications from Oracle Cloud Infrastructure - Classic to Oracle Cloud Infrastructure.

 * OpenAPI spec version: 20191031
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * An application running in the source environment that is available for export.
 *
 */
export interface SourceApplicationSummary {
    /**
     * The name of the application
     */
    "name"?: string;
    /**
     * The type of application
     */
    "type"?: model.MigrationTypes;
    /**
     * Unique identifier (OCID) for the Source to which the application belongs
     */
    "sourceId"?: string;
    /**
     * The version of the application server
     */
    "version"?: string;
    /**
     * The current application running state
     */
    "state"?: string;
}
export declare namespace SourceApplicationSummary {
    function getJsonObj(obj: SourceApplicationSummary): object;
}
