/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as serviceRequests from "./request";
import * as serviceResponses from "./response";
import * as models from "./model";
import { DatabaseClient } from "./client";
export declare class DatabaseWaiter {
    private client;
    private readonly config?;
    constructor(client: DatabaseClient, config?: Partial<import("oci-common/lib/waiter").WaiterConfigurationDetails> | undefined);
    /**
     * Waits forAutonomousContainerDatabase till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousContainerDatabaseResponse | null (null in case of 404 response)
     */
    forAutonomousContainerDatabase(request: serviceRequests.GetAutonomousContainerDatabaseRequest, ...targetStates: models.AutonomousContainerDatabase.LifecycleState[]): Promise<serviceResponses.GetAutonomousContainerDatabaseResponse | null>;
    /**
     * Waits forAutonomousContainerDatabaseDataguardAssociation till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousContainerDatabaseDataguardAssociationResponse | null (null in case of 404 response)
     */
    forAutonomousContainerDatabaseDataguardAssociation(request: serviceRequests.GetAutonomousContainerDatabaseDataguardAssociationRequest, ...targetStates: models.AutonomousContainerDatabaseDataguardAssociation.LifecycleState[]): Promise<serviceResponses.GetAutonomousContainerDatabaseDataguardAssociationResponse | null>;
    /**
     * Waits forAutonomousDataWarehouse till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousDataWarehouseResponse | null (null in case of 404 response)
     */
    forAutonomousDataWarehouse(request: serviceRequests.GetAutonomousDataWarehouseRequest, ...targetStates: models.AutonomousDataWarehouse.LifecycleState[]): Promise<serviceResponses.GetAutonomousDataWarehouseResponse | null>;
    /**
     * Waits forAutonomousDataWarehouseBackup till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousDataWarehouseBackupResponse | null (null in case of 404 response)
     */
    forAutonomousDataWarehouseBackup(request: serviceRequests.GetAutonomousDataWarehouseBackupRequest, ...targetStates: models.AutonomousDataWarehouseBackup.LifecycleState[]): Promise<serviceResponses.GetAutonomousDataWarehouseBackupResponse | null>;
    /**
     * Waits forAutonomousDatabase till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousDatabaseResponse | null (null in case of 404 response)
     */
    forAutonomousDatabase(request: serviceRequests.GetAutonomousDatabaseRequest, ...targetStates: models.AutonomousDatabase.LifecycleState[]): Promise<serviceResponses.GetAutonomousDatabaseResponse | null>;
    /**
     * Waits forAutonomousDatabaseBackup till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousDatabaseBackupResponse | null (null in case of 404 response)
     */
    forAutonomousDatabaseBackup(request: serviceRequests.GetAutonomousDatabaseBackupRequest, ...targetStates: models.AutonomousDatabaseBackup.LifecycleState[]): Promise<serviceResponses.GetAutonomousDatabaseBackupResponse | null>;
    /**
     * Waits forAutonomousDatabaseDataguardAssociation till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousDatabaseDataguardAssociationResponse | null (null in case of 404 response)
     */
    forAutonomousDatabaseDataguardAssociation(request: serviceRequests.GetAutonomousDatabaseDataguardAssociationRequest, ...targetStates: models.AutonomousDatabaseDataguardAssociation.LifecycleState[]): Promise<serviceResponses.GetAutonomousDatabaseDataguardAssociationResponse | null>;
    /**
     * Waits forAutonomousDatabaseWallet till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousDatabaseWalletResponse
     */
    forAutonomousDatabaseWallet(request: serviceRequests.GetAutonomousDatabaseWalletRequest, ...targetStates: models.AutonomousDatabaseWallet.LifecycleState[]): Promise<serviceResponses.GetAutonomousDatabaseWalletResponse>;
    /**
     * Waits forAutonomousExadataInfrastructure till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousExadataInfrastructureResponse | null (null in case of 404 response)
     */
    forAutonomousExadataInfrastructure(request: serviceRequests.GetAutonomousExadataInfrastructureRequest, ...targetStates: models.AutonomousExadataInfrastructure.LifecycleState[]): Promise<serviceResponses.GetAutonomousExadataInfrastructureResponse | null>;
    /**
     * Waits forAutonomousPatch till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousPatchResponse
     */
    forAutonomousPatch(request: serviceRequests.GetAutonomousPatchRequest, ...targetStates: models.AutonomousPatch.LifecycleState[]): Promise<serviceResponses.GetAutonomousPatchResponse>;
    /**
     * Waits forAutonomousVmCluster till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetAutonomousVmClusterResponse | null (null in case of 404 response)
     */
    forAutonomousVmCluster(request: serviceRequests.GetAutonomousVmClusterRequest, ...targetStates: models.AutonomousVmCluster.LifecycleState[]): Promise<serviceResponses.GetAutonomousVmClusterResponse | null>;
    /**
     * Waits forBackup till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetBackupResponse | null (null in case of 404 response)
     */
    forBackup(request: serviceRequests.GetBackupRequest, ...targetStates: models.Backup.LifecycleState[]): Promise<serviceResponses.GetBackupResponse | null>;
    /**
     * Waits forBackupDestination till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetBackupDestinationResponse | null (null in case of 404 response)
     */
    forBackupDestination(request: serviceRequests.GetBackupDestinationRequest, ...targetStates: models.BackupDestination.LifecycleState[]): Promise<serviceResponses.GetBackupDestinationResponse | null>;
    /**
     * Waits forCloudExadataInfrastructure till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetCloudExadataInfrastructureResponse | null (null in case of 404 response)
     */
    forCloudExadataInfrastructure(request: serviceRequests.GetCloudExadataInfrastructureRequest, ...targetStates: models.CloudExadataInfrastructure.LifecycleState[]): Promise<serviceResponses.GetCloudExadataInfrastructureResponse | null>;
    /**
     * Waits forCloudVmCluster till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetCloudVmClusterResponse | null (null in case of 404 response)
     */
    forCloudVmCluster(request: serviceRequests.GetCloudVmClusterRequest, ...targetStates: models.CloudVmCluster.LifecycleState[]): Promise<serviceResponses.GetCloudVmClusterResponse | null>;
    /**
     * Waits forConsoleConnection till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetConsoleConnectionResponse | null (null in case of 404 response)
     */
    forConsoleConnection(request: serviceRequests.GetConsoleConnectionRequest, ...targetStates: models.ConsoleConnection.LifecycleState[]): Promise<serviceResponses.GetConsoleConnectionResponse | null>;
    /**
     * Waits forDataGuardAssociation till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetDataGuardAssociationResponse | null (null in case of 404 response)
     */
    forDataGuardAssociation(request: serviceRequests.GetDataGuardAssociationRequest, ...targetStates: models.DataGuardAssociation.LifecycleState[]): Promise<serviceResponses.GetDataGuardAssociationResponse | null>;
    /**
     * Waits forDatabase till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetDatabaseResponse | null (null in case of 404 response)
     */
    forDatabase(request: serviceRequests.GetDatabaseRequest, ...targetStates: models.Database.LifecycleState[]): Promise<serviceResponses.GetDatabaseResponse | null>;
    /**
     * Waits forDatabaseSoftwareImage till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetDatabaseSoftwareImageResponse | null (null in case of 404 response)
     */
    forDatabaseSoftwareImage(request: serviceRequests.GetDatabaseSoftwareImageRequest, ...targetStates: models.DatabaseSoftwareImage.LifecycleState[]): Promise<serviceResponses.GetDatabaseSoftwareImageResponse | null>;
    /**
     * Waits forDbHome till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetDbHomeResponse | null (null in case of 404 response)
     */
    forDbHome(request: serviceRequests.GetDbHomeRequest, ...targetStates: models.DbHome.LifecycleState[]): Promise<serviceResponses.GetDbHomeResponse | null>;
    /**
     * Waits forDbNode till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetDbNodeResponse | null (null in case of 404 response)
     */
    forDbNode(request: serviceRequests.GetDbNodeRequest, ...targetStates: models.DbNode.LifecycleState[]): Promise<serviceResponses.GetDbNodeResponse | null>;
    /**
     * Waits forDbSystem till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetDbSystemResponse | null (null in case of 404 response)
     */
    forDbSystem(request: serviceRequests.GetDbSystemRequest, ...targetStates: models.DbSystem.LifecycleState[]): Promise<serviceResponses.GetDbSystemResponse | null>;
    /**
     * Waits forExadataInfrastructure till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetExadataInfrastructureResponse | null (null in case of 404 response)
     */
    forExadataInfrastructure(request: serviceRequests.GetExadataInfrastructureRequest, ...targetStates: models.ExadataInfrastructure.LifecycleState[]): Promise<serviceResponses.GetExadataInfrastructureResponse | null>;
    /**
     * Waits forExadataIormConfig till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetExadataIormConfigResponse
     */
    forExadataIormConfig(request: serviceRequests.GetExadataIormConfigRequest, ...targetStates: models.ExadataIormConfig.LifecycleState[]): Promise<serviceResponses.GetExadataIormConfigResponse>;
    /**
     * Waits forMaintenanceRun till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetMaintenanceRunResponse | null (null in case of 404 response)
     */
    forMaintenanceRun(request: serviceRequests.GetMaintenanceRunRequest, ...targetStates: models.MaintenanceRun.LifecycleState[]): Promise<serviceResponses.GetMaintenanceRunResponse | null>;
    /**
     * Waits forVmCluster till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetVmClusterResponse | null (null in case of 404 response)
     */
    forVmCluster(request: serviceRequests.GetVmClusterRequest, ...targetStates: models.VmCluster.LifecycleState[]): Promise<serviceResponses.GetVmClusterResponse | null>;
    /**
     * Waits forVmClusterNetwork till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetVmClusterNetworkResponse | null (null in case of 404 response)
     */
    forVmClusterNetwork(request: serviceRequests.GetVmClusterNetworkRequest, ...targetStates: models.VmClusterNetwork.LifecycleState[]): Promise<serviceResponses.GetVmClusterNetworkResponse | null>;
}
