/**
 * Data Safe API
 * APIs for using Oracle Data Safe.
 * OpenAPI spec version: 20181201
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A Data Safe Configuration that allows customer to enable Data Safe in their tenancy.
 */
export interface DataSafeConfiguration {
    /**
     * Indicates if Data Safe is enabled.
     */
    "isEnabled"?: boolean;
    /**
     * The URL of the Data Safe service.
     */
    "url"?: string;
    /**
     * The OCID of the tenancy used to enable Data Safe.
     */
    "compartmentId"?: string;
    /**
     * The specific time when Data Safe configuration was enabled.
     */
    "timeEnabled"?: Date;
    /**
     * The current state of Data Safe configuration.
     */
    "lifecycleState"?: model.LifecycleState;
    /**
      * Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm)
  * <p>
  Example: `{\"Department\": \"Finance\"}`
  *
      */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
      * Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm)
  * <p>
  Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
  *
      */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace DataSafeConfiguration {
    function getJsonObj(obj: DataSafeConfiguration): object;
}
