/**
 *
 *
 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
export interface ListStorageWorkRequestsRequest extends common.BaseRequest {
    /**
     * The ID of the compartment in which to list resources.
     */
    "compartmentId": string;
    /**
     * The Log Analytics namespace used for the request.
     *
     */
    "namespaceName": string;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either ascending (`ASC`) or descending (`DESC`).
     *
     */
    "sortOrder"?: ListStorageWorkRequestsRequest.SortOrder;
    /**
     * The field to sort by. Only one sort order may be provided. Default order for timeAccepted is descending. If no value is specified timeAccepted is default.
     *
     */
    "sortBy"?: ListStorageWorkRequestsRequest.SortBy;
    /**
     * storage operation type
     */
    "operationType"?: model.StorageOperationType;
    /**
     * storage operation status
     */
    "status"?: model.WorkRequestStatus;
    /**
     * storage operation started time
     */
    "timeStarted"?: Date;
    /**
     * storage operation time finished
     */
    "timeFinished"?: Date;
    /**
     * policy name e.g. purge policy
     */
    "policyName"?: string;
    /**
     * policy ID e.g. purge policy ID
     */
    "policyId"?: string;
}
export declare namespace ListStorageWorkRequestsRequest {
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
    enum SortBy {
        TimeAccepted = "timeAccepted",
        TimeExpires = "timeExpires",
        TimeFinished = "timeFinished"
    }
}
