/**
 * ManagementDashboard API
 * Management Dashboard micro-service provides a set of CRUD, import, export, and compartment related APIs (such as change compartment)   to support dashboard and saved search metadata preservation.  These APIs are mainly for client UIs, for various UI activities such as get list of all saved searches in a compartment, create a dashboard, open a saved search, etc.  Use export to retrieve  dashboards and their saved searches, then edit the Json if necessary (for example change compartmentIds), then import the result to  destination dashboard service.
APIs validate all required properties to ensure properties are present and have correct type and values.
    

 * OpenAPI spec version: 20200901
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as ChangeManagementDashboardsCompartmentDetails from "./change-management-dashboards-compartment-details";
export import ChangeManagementDashboardsCompartmentDetails = ChangeManagementDashboardsCompartmentDetails.ChangeManagementDashboardsCompartmentDetails;
import * as ChangeManagementSavedSearchesCompartmentDetails from "./change-management-saved-searches-compartment-details";
export import ChangeManagementSavedSearchesCompartmentDetails = ChangeManagementSavedSearchesCompartmentDetails.ChangeManagementSavedSearchesCompartmentDetails;
import * as CreateManagementDashboardDetails from "./create-management-dashboard-details";
export import CreateManagementDashboardDetails = CreateManagementDashboardDetails.CreateManagementDashboardDetails;
import * as CreateManagementSavedSearchDetails from "./create-management-saved-search-details";
export import CreateManagementSavedSearchDetails = CreateManagementSavedSearchDetails.CreateManagementSavedSearchDetails;
import * as LifecycleStates from "./lifecycle-states";
export import LifecycleStates = LifecycleStates.LifecycleStates;
import * as ManagementDashboard from "./management-dashboard";
export import ManagementDashboard = ManagementDashboard.ManagementDashboard;
import * as ManagementDashboardCollection from "./management-dashboard-collection";
export import ManagementDashboardCollection = ManagementDashboardCollection.ManagementDashboardCollection;
import * as ManagementDashboardExportDetails from "./management-dashboard-export-details";
export import ManagementDashboardExportDetails = ManagementDashboardExportDetails.ManagementDashboardExportDetails;
import * as ManagementDashboardForImportExportDetails from "./management-dashboard-for-import-export-details";
export import ManagementDashboardForImportExportDetails = ManagementDashboardForImportExportDetails.ManagementDashboardForImportExportDetails;
import * as ManagementDashboardImportDetails from "./management-dashboard-import-details";
export import ManagementDashboardImportDetails = ManagementDashboardImportDetails.ManagementDashboardImportDetails;
import * as ManagementDashboardSummary from "./management-dashboard-summary";
export import ManagementDashboardSummary = ManagementDashboardSummary.ManagementDashboardSummary;
import * as ManagementDashboardTileDetails from "./management-dashboard-tile-details";
export import ManagementDashboardTileDetails = ManagementDashboardTileDetails.ManagementDashboardTileDetails;
import * as ManagementSavedSearch from "./management-saved-search";
export import ManagementSavedSearch = ManagementSavedSearch.ManagementSavedSearch;
import * as ManagementSavedSearchCollection from "./management-saved-search-collection";
export import ManagementSavedSearchCollection = ManagementSavedSearchCollection.ManagementSavedSearchCollection;
import * as ManagementSavedSearchForImportDetails from "./management-saved-search-for-import-details";
export import ManagementSavedSearchForImportDetails = ManagementSavedSearchForImportDetails.ManagementSavedSearchForImportDetails;
import * as ManagementSavedSearchSummary from "./management-saved-search-summary";
export import ManagementSavedSearchSummary = ManagementSavedSearchSummary.ManagementSavedSearchSummary;
import * as SavedSearchTypes from "./saved-search-types";
export import SavedSearchTypes = SavedSearchTypes.SavedSearchTypes;
import * as SortOrders from "./sort-orders";
export import SortOrders = SortOrders.SortOrders;
import * as UpdateManagementDashboardDetails from "./update-management-dashboard-details";
export import UpdateManagementDashboardDetails = UpdateManagementDashboardDetails.UpdateManagementDashboardDetails;
import * as UpdateManagementSavedSearchDetails from "./update-management-saved-search-details";
export import UpdateManagementSavedSearchDetails = UpdateManagementSavedSearchDetails.UpdateManagementSavedSearchDetails;
